package com.tzld.piaoquan.longarticle.service.remote.impl;


import cn.hutool.core.collection.CollectionUtil;
import com.alibaba.fastjson.JSON;
import com.tzld.piaoquan.longarticle.model.dto.ArticleSortRequest;
import com.tzld.piaoquan.longarticle.model.dto.ArticleSortResponse;
import com.tzld.piaoquan.longarticle.service.remote.SortService;
import com.tzld.piaoquan.longarticle.utils.HttpClientUtil;
import com.tzld.piaoquan.longarticle.utils.HttpPoolClientUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.Objects;

@Slf4j
@Service
public class SortServiceImpl implements SortService {

    HttpPoolClientUtil HTTP_POOL_CLIENT_UTIL_DEFAULT = HttpClientUtil.create(5000, 200000, 20, 100, 3, 3000);

    public ArticleSortResponse publishArticleSort(ArticleSortRequest request) {
        ArticleSortResponse response = new ArticleSortResponse();
        String apiUrl = "http://101.37.174.139:80/recommend";
        long startTime = System.currentTimeMillis();
        try {
            String res = HTTP_POOL_CLIENT_UTIL_DEFAULT.post(apiUrl, JSON.toJSONString(request));
            log.info("publishArticleSort request={} res={}", request, res);
            long endTime = System.currentTimeMillis();
            log.info("publishArticleSort request={} needTime={}", request, endTime - startTime);
            response = JSON.parseObject(res, ArticleSortResponse.class);
            if (Objects.nonNull(response) && Objects.nonNull(response.getData())) {
                response.setSuccessful(true);
                if (CollectionUtil.isNotEmpty(response.getData().getRank_list())) {
                    return response;
                }
            }
        } catch (Exception e) {
            log.error("publishArticleSort recommend response parseObject", e);
        }
        long endTime = System.currentTimeMillis();
        log.info("publishArticleSort request={} needTime={}", request, endTime - startTime);
        return response;
    }

}
